diff --git a/tests/Makefile.sources b/tests/Makefile.sources
index 6d081c3..ffd59c1 100644
--- a/tests/Makefile.sources
+++ b/tests/Makefile.sources
@@ -105,6 +105,7 @@ TESTS_progs_M = \
 	kms_pipe_color \
 	kms_pipe_crc_basic \
 	kms_plane \
+	kms_plane_multiple \
 	kms_properties \
 	kms_psr_sink_crc \
 	kms_render \
diff --git a/tests/kms_plane_multiple.c b/tests/kms_plane_multiple.c
new file mode 100644
index 0000000..a18cdff
--- /dev/null
+++ b/tests/kms_plane_multiple.c
@@ -0,0 +1,475 @@
+/*
+ * Copyright © 2016 Intel Corporation
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
+ * IN THE SOFTWARE.
+ *
+ */
+
+#include "igt.h"
+#include "drmtest.h"
+#include <errno.h>
+#include <stdbool.h>
+#include <stdio.h>
+#include <string.h>
+#include <time.h>
+
+IGT_TEST_DESCRIPTION("Test atomic mode setting with multiple planes ");
+
+#define MAX_CRCS 1
+#define SIZE     128
+
+#define IN_RANGE(X, MIN, MAX) ((X) < (MIN) || (X) > (MAX) ? 16 : X)
+
+typedef struct {
+	float red;
+	float green;
+	float blue;
+} color_t;
+
+typedef struct {
+	int drm_fd;
+	igt_display_t display;
+	igt_pipe_crc_t *pipe_crc;
+	igt_plane_t *plane[IGT_MAX_PLANES];
+	struct igt_fb fb[IGT_MAX_PLANES];
+} data_t;
+
+typedef struct {
+	data_t *data;
+	igt_crc_t reference_crc;
+} test_position_t;
+
+/* Command line parameters. */
+struct {
+	unsigned iterations;
+	bool user_seed;
+	int seed;
+	bool user_logfile;
+	char logfile[SIZE];
+} opt = {
+	.iterations = 16,
+	.user_seed = false,
+	.seed = 1,
+	.user_logfile = false,
+	.logfile = "kms_plane_multiple.log",
+};
+
+static inline uint32_t pipe_select(int pipe)
+{
+	if (pipe > 1)
+		return pipe << DRM_VBLANK_HIGH_CRTC_SHIFT;
+	else if (pipe > 0)
+		return DRM_VBLANK_SECONDARY;
+	else
+		return 0;
+}
+
+static unsigned get_vblank(int fd, int pipe, unsigned flags)
+{
+	union drm_wait_vblank vbl;
+
+	memset(&vbl, 0, sizeof(vbl));
+	vbl.request.type = DRM_VBLANK_RELATIVE | pipe_select(pipe) | flags;
+	if (drmIoctl(fd, DRM_IOCTL_WAIT_VBLANK, &vbl))
+		return 0;
+
+	return vbl.reply.sequence;
+}
+
+static int logwrite(const char *testname)
+{
+	time_t curr_time;
+	FILE *fid;
+	char *time_str;
+
+	fid = fopen(opt.logfile, "a");
+
+	if (fid == NULL) {
+		igt_debug("Could not open file %s\n", opt.logfile);
+		return -1;
+	}
+
+	curr_time = time(NULL);
+
+	time_str = ctime(&curr_time);
+	time_str[strlen(time_str)-1] = '\0';
+
+	fprintf(fid, "%s: kms_plane_multiple --run-subtest %s --seed %d\n",
+		time_str, testname, opt.seed);
+
+	fclose(fid);
+
+	return 0;
+}
+
+/*
+ * Common code across all tests, acting on data_t
+ */
+static void test_init(data_t *data, enum pipe pipe)
+{
+	data->pipe_crc = igt_pipe_crc_new(pipe, INTEL_PIPE_CRC_SOURCE_AUTO);
+}
+
+static void test_fini(data_t *data, igt_output_t *output, int max_planes)
+{
+	igt_plane_set_fb(data->plane[IGT_PLANE_PRIMARY], NULL);
+
+	for (int i = IGT_PLANE_2; i <= max_planes; i++)
+		igt_plane_set_fb(data->plane[i], NULL);
+
+	/* reset the constraint on the pipe */
+	igt_output_set_pipe(output, PIPE_ANY);
+
+	igt_pipe_crc_free(data->pipe_crc);
+}
+
+static bool test_is_atomic(const char *testname)
+{
+	if (strncmp(testname, "atomic", 6) == 0)
+		return true;
+
+	return false;
+}
+
+static void
+test_grab_crc(data_t *data, igt_output_t *output, enum pipe pipe,
+	      color_t *color, uint64_t tiling, igt_crc_t *crc /* out */)
+{
+	struct igt_fb fb;
+	drmModeModeInfo *mode;
+	igt_plane_t *primary;
+	int n;
+	bool test_atomic = test_is_atomic(igt_subtest_name());
+
+	igt_output_set_pipe(output, pipe);
+
+	primary = igt_output_get_plane(output, IGT_PLANE_PRIMARY);
+
+	mode = igt_output_get_mode(output);
+
+	igt_create_color_fb(data->drm_fd, mode->hdisplay, mode->vdisplay,
+			    DRM_FORMAT_XRGB8888,
+			    LOCAL_DRM_FORMAT_MOD_NONE,
+			    color->red, color->green, color->blue,
+			    &fb);
+
+	igt_plane_set_fb(primary, &fb);
+
+	igt_display_commit2(&data->display,
+			    test_atomic ? COMMIT_ATOMIC : COMMIT_LEGACY);
+
+	igt_pipe_crc_start(data->pipe_crc);
+	n = igt_pipe_crc_get_crcs(data->pipe_crc, 1, &crc);
+	igt_assert_eq(n, 1);
+	igt_pipe_crc_stop(data->pipe_crc);
+
+	igt_plane_set_fb(primary, NULL);
+
+	igt_display_commit2(&data->display,
+			    test_atomic ? COMMIT_ATOMIC : COMMIT_LEGACY);
+
+	igt_remove_fb(data->drm_fd, &fb);
+}
+
+/*
+ * Multiple plane position test.
+ *   - We start by grabbing a reference CRC of a full blue fb being scanned
+ *     out on the primary plane
+ *   - Then we scannout number of planes:
+ *      * the primary plane uses a blue fb with a black rectangle hole
+ *      * planes, on top of the primary plane, with a blue fb that is set-up
+ *        to cover the black rectangles of the primary plane fb
+ *     The resulting CRC should be identical to the reference CRC
+ */
+
+static void
+create_fb_for_mode_position(data_t *data, drmModeModeInfo *mode,
+			    color_t *color, int *rect_x, int *rect_y,
+			    int rect_w, int rect_h, uint64_t tiling,
+			    int max_planes)
+{
+	unsigned int fb_id;
+	cairo_t *cr;
+
+	fb_id = igt_create_fb(data->drm_fd,
+			      mode->hdisplay, mode->vdisplay,
+			      DRM_FORMAT_XRGB8888,
+			      tiling,
+			      &data->fb[IGT_PLANE_PRIMARY]);
+	igt_assert(fb_id);
+
+	cr = igt_get_cairo_ctx(data->drm_fd, &data->fb[IGT_PLANE_PRIMARY]);
+	igt_paint_color(cr, rect_x[0], rect_y[0],
+			mode->hdisplay, mode->vdisplay,
+			color->red, color->green, color->blue);
+
+	for (int i = IGT_PLANE_2; i <= max_planes; i++)
+		igt_paint_color(cr, rect_x[i], rect_y[i],
+				rect_w, rect_h, 0.0, 0.0, 0.0);
+
+	igt_assert(cairo_status(cr) == 0);
+	cairo_destroy(cr);
+}
+
+
+static void
+test_planes(data_t *data, enum pipe pipe, color_t *color,
+	    uint64_t tiling, int max_planes, igt_output_t *output)
+{
+	drmModeModeInfo *mode;
+	int x[IGT_MAX_PLANES];
+	int y[IGT_MAX_PLANES];
+	int i;
+
+	igt_output_set_pipe(output, pipe);
+
+	mode = igt_output_get_mode(output);
+
+	/* sprite planes with random positions */
+	x[IGT_PLANE_PRIMARY] = 0;
+	y[IGT_PLANE_PRIMARY] = 0;
+	for (i = IGT_PLANE_2; i <= max_planes; i++) {
+		x[i] = rand() % (mode->hdisplay - SIZE);
+		y[i] = rand() % (mode->vdisplay - SIZE);
+
+		data->plane[i] = igt_output_get_plane(output, i);
+
+		igt_create_color_fb(data->drm_fd,
+				    SIZE, SIZE, /* width, height */
+				    data->plane[i]->is_cursor ? DRM_FORMAT_ARGB8888 : DRM_FORMAT_XRGB8888,
+				    tiling,
+				    color->red, color->green, color->blue,
+				    &data->fb[i]);
+
+		igt_plane_set_position(data->plane[i], x[i], y[i]);
+		igt_plane_set_fb(data->plane[i], &data->fb[i]);
+	}
+
+	/* primary plane */
+	data->plane[IGT_PLANE_PRIMARY] = igt_output_get_plane(output, IGT_PLANE_PRIMARY);
+	create_fb_for_mode_position(data, mode, color, x, y,
+				    SIZE, SIZE, tiling, max_planes);
+	igt_plane_set_fb(data->plane[IGT_PLANE_PRIMARY], &data->fb[IGT_PLANE_PRIMARY]);
+}
+
+static void
+test_plane_position_with_output(data_t *data, enum pipe pipe, igt_output_t *output,
+				int max_planes, uint64_t tiling)
+{
+	char buf[SIZE];
+	struct drm_event *e = (void *)buf;
+	test_position_t test = { .data = data };
+	color_t blue  = { 0.0f, 0.0f, 1.0f };
+	bool test_atomic = test_is_atomic(igt_subtest_name());
+	igt_crc_t *crc = NULL;
+	igt_crc_t crc_legacy;
+	unsigned vblank_start;
+	int n, ret;
+
+	if (test_atomic)
+		igt_require(data->display.is_atomic);
+
+	igt_info("Testing connector %s using pipe %s with %d planes for %d %s\n",
+		 igt_output_name(output), kmstest_pipe_name(pipe), max_planes,
+		 opt.iterations, opt.iterations > 1 ? "iterations" : "iteration");
+
+	test_init(data, pipe);
+
+	test_grab_crc(data, output, pipe, &blue, tiling,
+		      &test.reference_crc);
+
+	if (test_atomic)
+		igt_pipe_crc_start(data->pipe_crc);
+
+	for (int i = 0; i < opt.iterations; i++) {
+		test_planes(data, pipe, &blue, tiling, max_planes, output);
+
+		if (test_atomic) {
+			vblank_start = get_vblank(data->display.drm_fd, pipe, DRM_VBLANK_NEXTONMISS);
+
+			igt_display_commit_atomic(&data->display,
+						  DRM_MODE_PAGE_FLIP_EVENT,
+						  &data->display);
+
+			ret = read(data->display.drm_fd, buf, sizeof(buf));
+
+			igt_assert_eq(get_vblank(data->display.drm_fd, pipe, 0), vblank_start + 1);
+			igt_set_timeout(1, "Stuck on page flip");
+			igt_assert_neq(errno, EINTR);
+			igt_assert_neq(errno, EAGAIN);
+			igt_assert(ret >= 0);
+			igt_assert_eq(e->type, DRM_EVENT_FLIP_COMPLETE);
+
+			n = igt_pipe_crc_get_crcs(data->pipe_crc, MAX_CRCS, &crc);
+
+			igt_assert_eq(n, MAX_CRCS);
+		} else {
+			igt_display_commit2(&data->display, COMMIT_LEGACY);
+
+			igt_pipe_crc_collect_crc(data->pipe_crc, &crc_legacy);
+			crc = &crc_legacy;
+		}
+
+		igt_assert_crc_equal(&test.reference_crc, crc);
+	}
+
+	if (test_atomic)
+		igt_pipe_crc_stop(data->pipe_crc);
+
+	test_fini(data, output, max_planes);
+}
+
+static void
+test_plane_position(data_t *data, enum pipe pipe, int max_planes,
+		    uint64_t tiling)
+{
+	igt_output_t *output;
+	int connected_outs;
+
+	igt_skip_on(pipe >= data->display.n_pipes);
+	igt_skip_on(max_planes >= data->display.pipes[pipe].n_planes);
+
+	if (!opt.user_seed)
+		opt.seed = time(NULL);
+
+	srand(opt.seed);
+	logwrite(igt_subtest_name());
+
+	connected_outs = 0;
+	for_each_connected_output(&data->display, output) {
+		test_plane_position_with_output(data, pipe, output,
+						max_planes, tiling);
+		connected_outs++;
+	}
+
+	igt_skip_on(connected_outs == 0);
+
+}
+
+static void
+run_tests_for_pipe_plane(data_t *data, enum pipe pipe, int max_planes)
+{
+	igt_subtest_f("legacy-pipe-%s-tiling-none-planes-%d",
+		      kmstest_pipe_name(pipe), max_planes)
+		test_plane_position(data, pipe, max_planes, LOCAL_DRM_FORMAT_MOD_NONE);
+
+	igt_subtest_f("atomic-pipe-%s-tiling-none-planes-%d",
+		      kmstest_pipe_name(pipe), max_planes)
+		test_plane_position(data, pipe, max_planes, LOCAL_I915_FORMAT_MOD_X_TILED);
+
+	igt_subtest_f("legacy-pipe-%s-tiling-x-planes-%d",
+		      kmstest_pipe_name(pipe), max_planes)
+		test_plane_position(data, pipe, max_planes, LOCAL_I915_FORMAT_MOD_X_TILED);
+
+	igt_subtest_f("atomic-pipe-%s-tiling-x-planes-%d",
+		      kmstest_pipe_name(pipe), max_planes)
+		test_plane_position(data, pipe, max_planes, LOCAL_I915_FORMAT_MOD_X_TILED);
+
+	igt_subtest_f("legacy-pipe-%s-tiling-y-planes-%d",
+		      kmstest_pipe_name(pipe), max_planes)
+		test_plane_position(data, pipe, max_planes, LOCAL_I915_FORMAT_MOD_Y_TILED);
+
+	igt_subtest_f("atomic-pipe-%s-tiling-y-planes-%d",
+		      kmstest_pipe_name(pipe), max_planes)
+		test_plane_position(data, pipe, max_planes, LOCAL_I915_FORMAT_MOD_Y_TILED);
+
+	igt_subtest_f("legacy-pipe-%s-tiling-yf-planes-%d",
+		      kmstest_pipe_name(pipe), max_planes)
+		test_plane_position(data, pipe, max_planes, LOCAL_I915_FORMAT_MOD_Yf_TILED);
+
+	igt_subtest_f("atomic-pipe-%s-tiling-yf-planes-%d",
+		      kmstest_pipe_name(pipe), max_planes)
+		test_plane_position(data, pipe, max_planes, LOCAL_I915_FORMAT_MOD_Yf_TILED);
+}
+
+static void
+run_tests_for_pipe(data_t *data, enum pipe pipe)
+{
+	for (int planes = 1; planes < IGT_MAX_PLANES; planes++)
+		run_tests_for_pipe_plane(data, pipe, planes);
+}
+
+static data_t data;
+
+static int opt_handler(int option, int option_index, void *input)
+{
+	switch (option) {
+	case 'i':
+		opt.iterations = IN_RANGE(strtol(optarg, NULL, 0), 1, 256);
+		break;
+	case 's':
+		opt.user_seed = true;
+		opt.seed = strtol(optarg, NULL, 0);
+		break;
+	case 'l':
+		opt.user_logfile = true;
+		strcpy(opt.logfile, optarg);
+		break;
+	default:
+		igt_assert(false);
+	}
+
+	return 0;
+}
+
+const char *help_str =
+	"  --iterations Number of iterations for test coverage. min 1, max 256, default 16 iterations \n"
+	"  --seed       Seed for random number generator\n"
+	"  --logfile    Logfile to store seeds for random number generator, default 'kms_plane_multiple.log'\n";
+
+int main(int argc, char *argv[])
+{
+	time_t t = time(NULL);
+	struct tm tm = *localtime(&t);
+
+	struct option long_options[] = {
+		{ "iterations", required_argument, NULL, 'i'},
+		{ "seed",    required_argument, NULL, 's'},
+		{ "logfile", required_argument, NULL, 'l'},
+		{ 0, 0, 0, 0 }
+	};
+
+	igt_subtest_init_parse_opts(&argc, argv, "", long_options, help_str,
+				    opt_handler, NULL);
+
+	if (!opt.user_logfile)
+		sprintf(opt.logfile, "kms_plane_multiple-%4d-%2d-%2d.log",
+			tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday);
+
+	igt_skip_on_simulation();
+
+	igt_fixture {
+		data.drm_fd = drm_open_driver_master(DRIVER_INTEL);
+
+		kmstest_set_vt_graphics_mode();
+
+		igt_require_pipe_crc();
+		igt_display_init(&data.display, data.drm_fd);
+	}
+
+	for (int pipe = 0; pipe < I915_MAX_PIPES; pipe++)
+		run_tests_for_pipe(&data, pipe);
+
+	igt_fixture {
+		igt_display_fini(&data.display);
+	}
+
+	igt_exit();
+}